PROCEDURE faterror
*******************************************************************************************
*
* PROCEDURE faterror
*
* PROCEDURE LIBRARY: RETPROC.PRG
*
* CALLED FROM: SQLWRITE
*
* INPUTS: 
*     	cmess 		- error message
*		cmess1		- line with error in it
*		cprogname	- name of program with error in it.
*		nerrorcode 	- error code of error
*		nlineno		- line no of line with error in it
*
* PROCESS
*		calls faterror
*		Uses both Foxpro error numbers and use defined errors (beginning with the number 3000)
*		Accesses tblmess1 and  global variable Glfromstartup.
*		Modifies global variables gndispcode and gnerror.
*		When this procedure is called from STARTUP.PRG, THISFORMSET and all related global variables are not accessable.
* 		This includes the preffered language, therefore the message boxes are bilingual.
*
* OUTPUTS:
* 		same as inputs(used to pass parameters to fatal	error form.
*
***********************************************************************************************************

LPARAMETERS cmess, cmess1, cprogname, nerrcode, nlineno

gndispcode = 0						&& Contains the user's reponse to the message box (1 = OK, 2=Cancel)

IF gnerror = 0
	gnerror = nerrcode					&& Assign error number to global variable
ELSE 
	nerrcode = gnerror
ENDIF


IF Glfromstartup = .T.			&& Faterror is called from statrtup.prg

	DO CASE
		CASE nerrcode = 1569 OR nerrcode = 1881				&& Foxpro 1569 error - 'Database "name": File access denied.'
															&& Foxpro 1881 error - 'Error loading file - record number...'
			* In this case tblmess1 cannot be accessed because it is being use by another application.			
			
			wait 'error 1569 OR 1881 -file access denied' window
			cerrortype = 'E'
			cerrorcode = '00005'
			ctitlebartext = "Error Message / Message d'Erreur "  
			ctitlebartext = ctitlebartext + cerrorcode
			niconandtype = 64       && info sign + OK button
			Cmesstext = RTRIM('Another instance of this application is running. Exiting program... / ' ;
						+ chr(13) + 'CONVERT TO FRENCH')
			Gndispcode = MESSAGEBOX(Cmesstext,niconandtype,ctitlebartext)		
			SELECT (ncurrentworkarea)	
			ON ERROR							&& Clear the error handler
			
		CASE nerrcode = 1705				&& Foxpro error - ' File access denied.'
			* In this case tblmess1 cannot be accessed because it is being use by another application.			
			
*!*				wait 'error 1705 -file access denied' window
			cerrortype = 'E'
			cerrorcode = '00005'
			ctitlebartext = "Error Message / Message d'Erreur "  
			ctitlebartext = ctitlebartext + cerrorcode
			niconandtype =  64       && info sign + OK button
			Cmesstext = RTRIM('Another instance of this application is running. Exiting program... / ' ;
						+ chr(13) + 'CONVERT TO FRENCH')
			Gndispcode = MESSAGEBOX(Cmesstext,niconandtype,ctitlebartext)		
			SELECT (ncurrentworkarea)	
			ON ERROR							&& Clear the error handler
			
		CASE nerrcode = 15 OR nerrcode = 13		&& If file is not a table
			SELECT tblmess1 
			LOCATE FOR cmesscode = 'I00031'
			cerrortype = SUBSTR(cmesscode,1,1)
			cerrorcode = SUBSTR(cmesscode,2,5)	
			ctitlebartext = "Error Message / Message d'Erreur "  
			ctitlebartext = ctitlebartext + cerrorcode
			niconandtype =  64       && info sign + OK button
			Cmesstext = RTRIM(Cmesstexte) + ' / ' + chr(13) + RTRIM(Cmesstextf)
			Gndispcode = MESSAGEBOX(Cmesstext,niconandtype,ctitlebartext)		
			SELECT (ncurrentworkarea)	
			ON ERROR							&& Clear the error handler
	
		CASE nerrcode = 3001 					&& Foxpro does not use this number, traps error if file does not exist
			SELECT tblmess1 
			LOCATE FOR cmesscode = 'I00027'
			cerrortype = SUBSTR(cmesscode,1,1)
			cerrorcode = SUBSTR(cmesscode,2,5)	
			ctitlebartext = "Error Message / Message d'Erreur "  
			ctitlebartext = ctitlebartext + cerrorcode
			niconandtype = 49       			&& stop sign + OK button
			Cmesstext = RTRIM(Cmesstexte) + ' / ' + chr(13) + RTRIM(Cmesstextf)
			Gndispcode = MESSAGEBOX(Cmesstext,niconandtype,ctitlebartext)		
			SELECT (ncurrentworkarea)			
			ON ERROR						&& Clear the error handler
			
		CASE nerrcode = 3000				&& Foxpro does not use this number, traps error when another instance of program is running
			SELECT tblmess1 
			LOCATE FOR cmesscode = 'I00032'
			cerrortype = SUBSTR(cmesscode,1,1)
			cerrorcode = SUBSTR(cmesscode,2,5)	
			ctitlebartext = "Error Message / Message d'Erreur "  
			ctitlebartext = ctitlebartext + cerrorcode
			niconandtype = 64       		&& Info sign + OK button
			Cmesstext = RTRIM(Cmesstexte) + ' / ' + chr(13) + RTRIM(Cmesstextf)
			Gndispcode = MESSAGEBOX(Cmesstext,niconandtype,ctitlebartext)		
			SELECT (ncurrentworkarea)
							
		CASE cmess = 'Invalid path or file name.'		
			SELECT tblmess1 
			gnerror = 3002
			LOCATE FOR cmesscode = 'I00028'
			cerrortype = SUBSTR(cmesscode,1,1)
			cerrorcode = SUBSTR(cmesscode,2,5)	
			ctitlebartext = "Error Message / Message d'Erreur "  
			ctitlebartext = ctitlebartext + cerrorcode
			niconandtype = 64       		&& Info sign + OK button

			Cmesstext = RTRIM(Cmesstexte) + ' / ' + chr(13) + RTRIM(Cmesstextf)

			Gndispcode = MESSAGEBOX(Cmesstext,niconandtype,ctitlebartext)		
			SELECT (ncurrentworkarea)	
			on error		
		OTHERWISE
			DO FORM faterror WITH cmess, cmess1, cprogname, nerrcode, nlineno
	ENDCASE
ELSE													&& Faterror is called from main program
*!*		wait 'error outside startup.prg' window
	DO CASE
*!*			CASE nerrcode = 1881		&& Another instance is running and cannot load an object in FRSRetrieval
*!*				ncurrentworkarea = SELECT(0)
*!*				SELECT tblmess1
*!*			
*!*				LOCATE FOR RTRIM(tblmess1.cmesscode) =  'I00032'
*!*	*!*				wait 'message=' + cmesscode window
*!*				cerrortype = SUBSTR(cmesscode,1,1)
*!*				cerrorcode = SUBSTR(cmesscode,2,5)		
*!*					IF Gclanguage = 'E'
*!*					ctitlebartext = 'Error Message '  
*!*				ELSE Gclanguage = 'F'
*!*					ctitlebartext = "Message d'Erreur "
*!*				ENDIF
*!*				ctitlebartext = ctitlebartext + cerrorcode
*!*				niconandtype = 64       && info sign + OK button		
*!*					
*!*				IF Gclanguage = 'E'
*!*					Cmesstext = RTRIM(Cmesstexte) 
*!*	*!*					wait 'message=' + Cmesstext window
*!*				ELSE
*!*				IF Gclanguage = 'F'
*!*					Cmesstext = RTRIM(Cmesstextf)
*!*				ENDIF									
*!*				ENDIF
*!*				Gndispcode = MESSAGEBOX(Cmesstext,niconandtype,ctitlebartext)		
*!*				SELECT (ncurrentworkarea)	
*!*				ON ERROR			&& Clear the error handler
*!*				Gndispcode = 0		&& Clear the error number
*!*				
		CASE nerrcode = 15 OR nerrcode = 13
			 
			ncurrentworkarea = SELECT(0)
			SELECT tblmess1
		
			LOCATE FOR RTRIM(tblmess1.cmesscode) =  'I00031'
*!*				wait 'message=' + cmesscode window
			cerrortype = SUBSTR(cmesscode,1,1)
			cerrorcode = SUBSTR(cmesscode,2,5)		
				IF Gclanguage = 'E'
				ctitlebartext = 'Error Message '  
			ELSE Gclanguage = 'F'
				ctitlebartext = "Message d'Erreur "
			ENDIF
			ctitlebartext = ctitlebartext + cerrorcode
			niconandtype = 64       && info sign + OK button		
				
			IF Gclanguage = 'E'
				Cmesstext = RTRIM(Cmesstexte) 
*!*					wait 'message=' + Cmesstext window
			ELSE
			IF Gclanguage = 'F'
				Cmesstext = RTRIM(Cmesstextf)
			ENDIF									
			ENDIF
			Gndispcode = MESSAGEBOX(Cmesstext,niconandtype,ctitlebartext)		
			SELECT (ncurrentworkarea)	
			ON ERROR			&& Clear the error handler
			
		OTHERWISE
			DO FORM faterror WITH cmess, cmess1, cprogname, nerrcode, nlineno
	ENDCASE	
ENDIF

ENDPROC


PROCEDURE CHECKDATADIR
********************************************************************************************************************
*
* PROCEDURE:			CHECKDATADIR
*
* PROCEDURE LIBRARY:	RETPROC.PRG
*
* CALLED FROM:			STARTUP.PRG
*						FRSRETRIEVAL.TBRRETRIEVAL.CMDDATADIR.CLICK
*
* PARAMETERS:			LVALIDDIR:	LOGICAL FLAG, 'TRUE' INDICATES ALL SLIDDBF FILES ARE 
*									LOCATED IN THE SELECTED DIRECTORIES
*
* PROCESS: 
* 	THIS PROCEDURE ENSURES THAT ALL SLIDDBF TABLES ARE LOCATED IN THE SELECTED DIRECTORY.
*	THIS IS DONE BY CHECKING ALL DATA TABLES LISTED tbltable.
*	IF THE TABLE IS LONGITUDINAL THEN THE SUBDIRECTORIES FOR ALL YEARS ARE CHECKED,
* 	OTHERWISE ONLY THE ROOT DIRECTORY IS SEARCHED.
*	THE LISTING FOR SLIDDBF TABLES IS CONTAINED IN tbltable.
*	TBLYEAR LISTS ONLY THOSE YEARS FOR WHICH ALL SLIDDBF TABLES EXIST.
* 
* MAINTENANCE DONE:
*	May 1999
*	If a longitudinal .dbf file is missing, the wrong filename may be displayed.
*	The filename of the missing file contains the year, but instead of displaying
*	the year in question, the maximum year (from tblyear) is shown.
*	To correct this, added an EXIT stmt to break out of the year loop when a .dbf
*	file cannot be found.
*
*	September 1999
*	The year subdirectory for the data tables has been renamed from 'yr9999' to 'year9999'
*	For example, ...\yr1996\xxxxxx.dbf has now become ...\year1996\xxxxxx.dbf
*
*	October 1999
*	Previously, if any datasets were missing, False would be returned to the calling program,
*	and you would be prompted to select another directory.  This has changed so that any years
*	missing longitudinal tables would be marked as unusable (tblyear.lvalid = .F.).
*	As long as the non-longitudinal tables were all present, and at least 1 year had a 
*	complete set of longitudinal tables, a True is returned (no directory prompt).
*	Any years missing data will not be displayed on frmSubtheme.
*
*********************************************************************************************************************

LPARAMETERS lvaliddata, cdir

LOCAL cmaxyear				&& The highest year listed in tblyear (used as max value in loop counter)
LOCAL cminyear				&& The lowest year listed in tblyear (used as min value in loop counter)
LOCAL lmissing
LOCAL nYearcnt				&& Number of records in tblyear
LOCAL nValidYear			&& Number of valid years (no data missing)


* Initialize variables
cdataloc = cdir
lmissing = .F.

SELECT tblyear
SET FILTER TO
* Mark all years as valid
SCAN
	REPLACE lvalid WITH .T.
ENDSCAN

SET TALK OFF						&& Do not display results of CALCULATE
* Get the highest and lowest year
CALCULATE MAX(cyear) TO cmaxyear
CALCULATE MIN(cyear) TO cminyear
SET TALK ON 

nmaxyear = VAL(cmaxyear)
nminyear = VAL(cminyear)
	
* Create array to keep track of those years that are missing longitudinal tables
nYearcnt = nmaxyear - nminyear + 1
DIMENSION alValidYear[nYearcnt]

* Initialize year array, assuming all years are valid
j = 1
FOR j=1 to nYearcnt	
	alValidYear[j] = .T.
ENDFOR

Ncurrentworkarea = SELECT()			&& Open table and check if all dbf files are in this dir
SELECT 0
USE tbltable
GO TOP
nMaxRec = RECCOUNT()
RECNO(0)

* Look for missing tables (non-longitudinal and longitudinal)
FOR i = 1 TO nMaxRec
*!*		lfilenotfound = .F.
	ctablename = RTRIM(tbltable.Tablename)
	
	IF tbltable.islongitudinal = .F.				&& Check for file in cdatadir
		cfilename = cdataloc + ctablename + '.dbf'			
		IF EMPTY(SYS(2000,cfilename))				&& file not found
			wait "Missing dataset/Fichier absent: " + cfilename window
			lmissing = .T.
			EXIT		&& If even one non-longitudinal table is missing, no sense continuing
		ENDIF
	ELSE
		j = 1										&& Index into year array											&& Check for file file in all year sub directories
		FOR iyr = nminyear TO nmaxyear
			cyr = 'year' + ALLTRIM(STR(iyr))
			cfilename = cdataloc + cyr + '\' + ctablename + '.dbf'
			IF EMPTY(SYS(2000,cfilename))			&& file not found
				IF alValidYear[j] = .T.				&& Print only 1 'missing' message per year
					wait "Missing dataset/Fichier absent: " + cfilename window
					alValidYear[j] = .F.			&& Year is marked as missing data
					* Mark year as invalid on tblyear
					SELECT tblyear
					LOCATE FOR tblyear.cyear = ALLTRIM(STR(iyr))
					IF FOUND()
						REPLACE tblyear.lvalid WITH .F.
					ENDIF
					SELECT tbltable
				ENDIF
			ENDIF	
			j = j + 1			
		ENDFOR
	ENDIF
		
	SKIP 1									&& Continue searching table
ENDFOR

SELECT tbltable								&& Close table
USE 

IF lmissing = .T.					&& Missing non-longitudinal table - prompt for new directory
	lvaliddata = .F.
ELSE
	nValidYear = ASCAN(alValidYear,.T.)
	IF nValidYear = 0	&& All years are missing data - prompt for new directory
		lvaliddata = .F.
	ELSE
		* Non-longitudinal tables are all present, and at least 1 year with complete data
		lvaliddata = .T.
	ENDIF
ENDIF

RETURN (lvaliddata)

ENDPROC




PROCEDURE WRITELINE
********************************************************************************************************************
*
* PROCEDURE: 	WRITELINE
*
* PURPOSE:		WRITES ONE OR MORE SQL CODED LINES TO THE QUERY FILE.
*				IF THE LINE THAT IS SENT THROUGH THE PARAMETER 'CLINE' IS MORE THAN
*				77 CHARACTERS, THE LINE IS SPLIT UP INTO 77 CHARACTER CHUNKS
*				AND WRITTEN OUT AS SUCH. 
*
* PROCEDURE LIBRARY: RETPROC.PRG
*
* CALLED FROM:	frsRetrieval.SQLWRITE
*				frsRetrieval.sqlwritelong
*				frsRetrieval.writetosas
*
* PARAMETERS:
*   CLINE:		IS THE LINE TO WRITE TO THE SQL CODED FILE.
* 	LNOSEMICOLON:	TELLS THE PROCEDURE WHETHER OR NOT TO PUT A SEMICOLON AT THE END
*					OF THE LINE IN ORDER TO CONTINUE THE LINE.
*	NFILEID:	is used to change the file being written to.
*	CFILENAME:	is used for the function FSIZE that determines the file size.
*	NLNO:		Optional parameter.  Gives the current global line (gl) being worked on.
*
* MAINTENANCE DONE:
*	July 1999
*	Problem with large SQL queries.  All available global lines (gl's) are being used
*	up, and the queries are still not finished.  If this happens, return to calling program.
*	
*	July 1999
*	"IF nlenleft = 0 ... ELSE" changed to
*	"IF nlenleft = 0 ... ENDIF".
*	This allows the current SQL query in parameter 'cline' to be handled by the following code.
*
*********************************************************************************************************************

LPARAMETER cline, Lnosemicolon, nfileid, cfilename,nlno
LOCAL clinenotwrote, clinetowrite, nbytesnotwrote, nbyteswrote, nposno, nfilesize
LOCAL nstartpos			&& start position of character in cline to be subbed
LOCAL lmore				&& True indicates there are more 254 chunks to process, used to continue or exit DO WHILE LOOP
LOCAL nlencline 		&& Number of characters in cline
LOCAL creturnstr 
LOCAL leolcline			&& True indicates end of line in cline has been reached, this flag terminates DO WHILE loop

nfilesize=FSIZE(cfilename)
fchstat=FCHSIZE(nfileid,nfilesize)

* Initialize Layout file variables
clinenotwrote = cline
nbytesnotwrote = LEN(clinenotwrote)   	&& bytes left to write
nbyteswrote = 0 						&& bytes written

* Initialize sql file variables
nstartpos = 1							&& Initialize starting position in SUBSTR() to first character
nlencline = LEN(cline)

IF EMPTY (nlno)							&& If writing to layout file
	nlrecl = 74
	lwritetosql = .F.
	lwritetolayout = .T.
ELSE									&& Writing to sql file
	nlrecl = 254
	lwritetosql = .T.
	lwritetolayout = .F.
ENDIF

IF lwritetosql
	clno = LTRIM(STR(nlno))
	
	IF gl&clno = ' '
		nlenleft = 254	
	ELSE
		nlenleft = 254 - LEN(gl&clno)           	&& length left to the max. char length for var. of 254
	ENDIF	
	
	* If cline requires more than one GL, then it is necessary to ensure that no GL's start with ".." as this will be 
	* misinterpreted by compiler. If a gl is found to begin with ".." then a blank character is inserted into cline, which
	* moves the breakpoint between gl's. This DO WHILE loop modifies cline but doesn't assign characters to any gl's.
	
	IF nlenleft < nlencline 			&& AN Additional Gl is required 
		leolcline = .F.					&& Initialize flag to false
		
		IF nlenleft = 254				&& If the starting gl is empty, then initial start is the 2nd 254 chunk in cline
			ninitialpos = 255
		ELSE							&& If the starting gl is not empty, then there is an offset in the 254 chunks
			ninitialpos = nlenleft + 1
		ENDIF
		
		ncurrpos = ninitialpos
	
		DO WHILE leolcline = .F.
			creturnstr = SUBSTR(cline,ncurrpos,2)
			
			IF creturnstr = '..'						&& Search backwards in cline for ',' or ' '
				lfound = .F.
				i = 1
				
				DO WHILE NOT lfound		
					ctemp2 = SUBSTR(cline,ncurrpos - i,1)
					
					IF ctemp2 = ' ' OR ctemp2 = ','
						cline = STUFF(cline,1 + ncurrpos - i, 0 , ' ')		&& Insert a blank after current position in cline
						ncurrpos = ninitialpos								&& Reset position in cline to initial position
						lfound = .T.
					ENDIF
					
					i = i + 1	
					
					IF ncurrpos - i = 0		&& This should never occur (reached end of cline without finding ',' or ' ')
*!*							wait 'reached end of cline' window
						lfound = .t.		&& This will cause an exit
					ENDIF
				ENDDO
			ELSE
				ncurrpos = ncurrpos + 254 		&&???????
				
				IF ncurrpos >= nlencline 
					leolcline = .T.
				ENDIF
			ENDIF
		ENDDO
	ENDIF		&& IF nlenleft < nlencline	
						
	* The current SQL line (gl) has reached the maximum of 254 bytes.
	* Write the gl out, and prepare a new gl to process the latest SQL query in parameter cline.
	IF nlenleft = 0	
		nfilesize = nfilesize + 254	
		fchstat = FCHSIZE(nfileid,nfilesize)
		fwrstat = FWRITE(nfileid,gl&clno)
		nlno = nlno + 1
		
		* Do we have enough declared strings (gl's) left to hold the SQL query?
		IF nlno > gnMaxgl
			RETURN
		ENDIF
		
		clno = LTRIM(str(nlno))
*!*			gl&clno = cline			&& This is not a smart thing to do!  What if cline is > 254 bytes?
		nlenleft = 254
	ENDIF
	
*!*		ELSE
	IF nlenleft >= nlencline 				&& just add the string
		IF gl&clno = ' '					&& all gl variables are init to spaces, we don't want this space in the SQL
			gl&clno = cline
*!*				wait 'adding to empty gl : ' + LTRIM(STR(NLENcline)) WINDOW
		ELSE
			gl&clno = gl&clno + cline
		ENDIF	
*		WAIT gl&clno window
	
	ELSE
	IF nlenleft < nlencline						&& If remaining blanks in global var are less than length of cline..
		lmore = .T.
		noffset = nlenleft
		
		IF gl&clno = ''							&& If current Gl is empty
			DO WHILE lmore = .T.			
				&&gl&clno = gl&clno + SUBSTR(cline,1,nlenleft) && divide the line in two parts: 1 pt. for the old line and 
				gl&clno = gl&clno + SUBSTR(cline,nstartpos,nlenleft)

				nfilesize = nfilesize + 254	
				fchstat = FCHSIZE(nfileid,nfilesize)
				fwrstat = FWRITE(nfileid,gl&clno)
*!*					wait 'write char to file=' + STR(fwrstat) window
*!*					? gl&clno								
				nlno = nlno + 1										&& Get next Gl variable
				clno = LTRIM(str(nlno))
				
				* Do we have enough declared strings (gl's) left to hold the SQL query?
				IF nlno > gnMaxgl
					RETURN
				ENDIF
				
				IF (nlencline - nstartpos - nlenleft + 1) > 254			&& If remaining chunk is more than 254 characters
					nstartpos = nstartpos + 254 
		*			nlenleft = 254	
					lmore = .T.										&& Repeat DO WHILE LOOP
		*			WAIT gl&clno window
				ELSE												&& If remaining chunck is less than 254 characters
					gl&clno = SUBSTR(cline,nstartpos + 254) 		&& Assign remaining characters to Gl
					lmore = .F.										&& exit DO WHILE LOOP
				ENDIF
			ENDDO		&& DO WHILE lmore = .T.
		
		ELSE			&& Current gl contains characters
			DO WHILE lmore = .T.
				IF nstartpos = 1									&& First time thru add enough char to fill gl
					gl&clno = gl&clno + SUBSTR(cline,nstartpos,nlenleft)
				ELSE									&& Remaining times thru add 254 char to gl because gl will be empty
					gl&clno = gl&clno + SUBSTR(cline,nstartpos,254)
				ENDIF
				
				nfilesize = nfilesize + 254	
				fchstat = FCHSIZE(nfileid,nfilesize)
				fwrstat = FWRITE(nfileid,gl&clno)
				nlno = nlno + 1										&& Get next Gl variable
				clno = LTRIM(str(nlno))
				
				* Do we have enough declared strings (gl's) left to hold the SQL query?
				IF nlno > gnMaxgl
					RETURN
				ENDIF
				
				IF (nlencline - nstartpos - nlenleft) > 254			&& If remaining chunk is more than 254 characters
*!*						WAIT 'REMAIN CHUNK > 254'WINDOW
					IF nstartpos = 1			&&bug??					&& First time thru add enough char to fill gl
						nstartpos = noffset + 1
					ELSE
						nstartpos = nstartpos + 254
					ENDIF
					
					nlenleft = 254	
					lmore = .T.										&& Repeat DO WHILE LOOP
		*			WAIT gl&clno window
				ELSE												&& If remaining chunk is less than 254 characters
*!*						IF LEN(cline) < 254
*!*						WAIT 'REMAIN CHUNK < 254'WINDOW
					IF nstartpos = 1
						nstartpos = noffset + 1
*!*							WAIT 'REMAIN CHUNK < 254'WINDOW
					ELSE
						nstartpos = nstartpos + 254 
					ENDIF
*!*						nstartpos = nstartpos + 254
					gl&clno = SUBSTR(cline,nstartpos) 				&& Assign remaining characters to Gl
					lmore = .F.										&& exit DO WHILE LOOP
				ENDIF
			ENDDO		&& DO WHILE lmore = .T.		
		ENDIF		&& IF gl&clno = ''
	ENDIF		&& IF nlenleft < nlencline
	ENDIF		&& IF nlenleft >= nlencline
*!*		ENDIF
					
ELSE
IF 	lwritetolayout
*!*		clinenotwrote = cline
*!*		nbytesnotwrote = LEN(clinenotwrote)   && bytes left to write
*!*		nbyteswrote = 0 && bytes written

*!*		nfilesize=FSIZE(cfilename)
*!*	*!*		nfilesize = nfilesize + 255	
*!*		fchstat=FCHSIZE(nfileid,nfilesize)

*   probably do not need a lot of this code that splits the line because the only input would be to the layout file.
*   and these are under 80 characters.
	DO WHILE .T.
		IF nbytesnotwrote = 0
			EXIT
		ENDIF	

		IF nbytesnotwrote > nlrecl
			FOR nbyteswrote = nlrecl TO 1 STEP -1  && Divide the line in two pieces.
	*			WAIT 'GREATER THAN 74' WINDOW
	*			WAIT clinenotwrote WINDOW	
	*			wait 'nbyteswrote=' + STR(nbyteswrote) window
	*			wait 'nbytesnotwrote=' + STR(nbytesnotwrote) window
				cbyte = SUBSTR(clinenotwrote,nbyteswrote,1)
	*			wait cbyte window
				IF cbyte = ',' OR cbyte = ' '  && you should be able to split the line at a , or ' '
					clinetowrite = PADR(SUBSTR(clinenotwrote,1,nbyteswrote),nlrecl)   && keep sub dividing line into 78 byte chunks
					clinenotwrote = SUBSTR(clinenotwrote,nbyteswrote + 1,nbytesnotwrote)
	*!*						WAIT 'CLINETOWRITE =' + clinetowrite WINDOW
	*!*					WAIT clinenotwrote WINDOW
					nbytesnotwrote = nbytesnotwrote - nbyteswrote
					csemicolon = ';'
					EXIT
				ENDIF
			ENDFOR
		ELSE
			clinetowrite = PADR(clinenotwrote,nlrecl)
	*		WAIT 'CLINETOWRITE =' + clinetowrite WINDOW
	
			IF lnosemicolon
				csemicolon = ' '
			ELSE
				csemicolon = ';'
			ENDIF
			
			nbytesnotwrote = 0
		ENDIF
		nfilesize = nfilesize + nlrecl + 3

		fchstat=FCHSIZE(nfileid,nfilesize)
	*!*		WAIT 'file size= ' + STR(fchstat) window	
		clinetowrite = clinetowrite + csemicolon
		fputstat= FPUTS(nfileid,clinetowrite)
	*!*		wait 'fput stat= ' + str(fputstat) window
	ENDDO		&& DO WHILE .T.
*   probably do not need a lot of this code that splits the line because the only input would 
*   be to the layout file and these are under 80 characters.
ENDIF		&& IF lwritetolayout
ENDIF		&& IF lwritetosql

ENDPROC

FUNCTION TRIMFILENAME
********************************************************************************************************************
*
* FUNCTION: TRIMFILENAME
*
* PROCEDURE LIBRARY: RETPROC.PRG
*
* CALLED FROM: 
*
* PARAMETERS: 	cfilepathname - Filename which includes path and may or may not include extension
*
* PROCESS:  	Accepts a file name with a path and returns the file name without the path. The file name 
* 				may or may not have an extension.
*
* RETURNS: 		The trimmed version of cfilepathname. If the file name is invalid (ie empty), an empty string is returned.
*
* 
*
*********************************************************************************************************************


LPARAMETER cfilepathname

LOCAL posofperiod 			&& Location of rightmost period in the string 'cfilename'
LOCAL posofslash 			&& Location of rightmost slash in the string 'cfilename'
LOCAL nlenoffname 			&& Number of characters in the string 'cfilename'
LOCAL lvalid 				&& Logical flag True indicates the file name has been successfully trimmed

cfilename = cfilepathname

IF NOT EMPTY(cfilename)		&& valid file name.
	posofperiod	= RAT('.',RTRIM(cfilename))
	IF posofperiod  = 0 				&& The file name does not have an extension
		posofslash = RAT('\',RTRIM(cfilename))
		nlenoffname = LEN(RTRIM(cfilename)) - posofslash    
		cfilename = SUBSTR(cfilename,posofslash + 1,nlenoffname)
		lvalid = .T.
	ELSE
		posofslash = RAT('\',RTRIM(cfilename))
		nlenoffname = LEN(RTRIM(cfilename)) - posofslash - 4   && the -4 is to take off the extension	
		cfilename = SUBSTR(cfilename,posofslash + 1,nlenoffname)
		lvalid = .T.
	ENDIF
ENDIF

IF lvalid = .T.
	RETURN cfilename 
ELSE
	RETURN {}			&& Filename was invalid, return an empty string
ENDIF

ENDFUNC

